# Copyright (C) 2010 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

from TagObject import TagObject

TAG_NAME = 'dlm'

class DLM(TagObject):
  DEFAULTS = {
    'protocol':             'detect',
    'timewarn':             '500',
    'log_debug':            '0',
    'enable_fencing':       '1',
    'enable_deadlk':        '0',
    'enable_quorum':        '0',
    'enable_plock':         '1',
    'plock_ownership':      '1',
    'plock_debug':          '0',
    'plock_rate_limit':     '0',
    'drop_resources_time':  '1000',
    'drop_resources_count': '10',
    'drop_resources_age':   '1000',
  }

  def __init__(self):
    TagObject.__init__(self)
    self.TAG_NAME = TAG_NAME

  def getLogDebug(self):
    return self.getBinaryAttribute('log_debug')

  def setLogDebug(self, val):
    return self.addBinaryAttribute('log_debug', val, ('0', '1'))

  def delLogDebug(self):
    return self.removeAttribute('log_debug')

  def getEnableFencing(self):
    return self.getBinaryAttribute('enable_fencing')

  def setEnableFencing(self, val):
    return self.addBinaryAttribute('enable_fencing', val, ('0', '1'))

  def delEnableFencing(self):
    return self.removeAttribute('enable_fencing')

  def getEnableQuorum(self):
    return self.getBinaryAttribute('enable_quorum')

  def setEnableQuorum(self, val):
    return self.addBinaryAttribute('enable_quorum', val, ('0', '1'))

  def delEnableQuorum(self):
    return self.removeAttribute('enable_quorum')

  def getEnableDeadlk(self):
    return self.getBinaryAttribute('enable_deadlk')

  def delEnableDeadlk(self):
    return self.removeAttribute('enable_deadlk')

  def setEnableDeadlk(self, val):
    return self.addBinaryAttribute('enable_deadlk', val, ('0', '1'))

  def getEnablePlock(self):
    return self.getBinaryAttribute('enable_plock')

  def setEnablePlock(self, val):
    return self.addBinaryAttribute('enable_plock', val, ('0', '1'))

  def delEnablePlock(self):
    return self.removeAttribute('enable_plock')

  def getEnablePlockDebug(self):
    return self.getBinaryAttribute('enable_plock_debug')

  def setEnablePlockDebug(self, val):
    return self.addBinaryAttribute('enable_plock_debug', val, ('0', '1'))

  def delEnablePlockDebug(self):
    return self.removeAttribute('enable_plock_debug')

  def getPlockRatelimit(self):
    return self.getBinaryAttribute('plock_rate_limit')

  def setPlockRatelimit(self, val):
    return self.addBinaryAttribute('plock_rate_limit', val, ('0', '1'))

  def delPlockRatelimit(self):
    return self.removeAttribute('plock_rate_limit')

  def getPlockOwnership(self):
    return self.getBinaryAttribute('plock_ownership')

  def setPlockOwnership(self, val):
    return self.addBinaryAttribute('plock_ownership', val, ('0', '1'))

  def delPlockOwnership(self):
    return self.removeAttribute('plock_ownership')

  def getTimeWarn(self):
    return self.getAttribute('timewarn')

  def setTimeWarn(self, val):
    return self.addIntegerAttribute('timewarn', val)

  def delTimeWarn(self):
    return self.removeAttribute('timewarn')

  def getProtocol(self):
    return self.getAttribute('protocol')

  def setProtocol(self, val):
    return self.addAttribute('protocol', val)

  def delProtocol(self):
    return self.removeAttribute('protocol')

  def getDropResourcesTime(self):
    return self.getAttribute('drop_resources_time')

  def setDropResourcesTime(self, val):
    return self.addIntegerAttribute('drop_resources_time', val)

  def delDropResourcesTime(self):
    return self.removeAttribute('drop_resources_time')

  def getDropResourcesCount(self):
    return self.getAttribute('drop_resources_count')

  def setDropResourcesCount(self, val):
    return self.addIntegerAttribute('drop_resources_count', val)

  def delDropResourcesCount(self):
    return self.removeAttribute('drop_resources_count')

  def getDropResourcesAge(self):
    return self.getAttribute('drop_resources_age')

  def setDropResourcesAge(self, val):
    return self.addIntegerAttribute('drop_resources_age', val)

  def delDropResourcesAge(self):
    return self.removeAttribute('drop_resources_age')
